/*----------------------------------------------------------------------------
 *      Name:    DEMO.C
 *      Purpose: USB HID Demo
 *      Version: V1.10
 *----------------------------------------------------------------------------
 *      This file is part of the uVision/ARM development tools.
 *      This software may only be used under the terms of a valid, current,
 *      end user licence from KEIL for a compatible version of KEIL software
 *      development tools. Nothing else gives you the right to this software.
 *
 *      Copyright (c) 2005-2007 Keil Software.
 *---------------------------------------------------------------------------*/

#include <stm32f10x_lib.h>                           // stm32f10x definitions

#include "type.h"

#include "usbreg.h"
#include "usb.h"
#include "usbcfg.h"
#include "usbhw.h"
#include "usbcore.h"

#include "STM32_Init.h"                              // stm32 initialisation
#include "MIE/Interfaces.h"
#include "demo.h"


BYTE InReport[8];                                       // HID Input Report
                                                     //   Bit0..1: Buttons
                                                     //   Bit2..7: Reserved

BYTE OutReport;                                      // HID Out Report
                                                     //   Bit0..7: LEDs


/*----------------------------------------------------------------------------
  Get HID Input Report -> InReport
 *----------------------------------------------------------------------------*/
void GetInReport (void) 
{
		outMapleFrame.Command		=	GetCondition;
		outMapleFrame.DestAP		=	0x20;
		outMapleFrame.OriginAP	=	0x00;
		outMapleFrame.DataSize	=	0x01;

		outMapleFrame.Data.dwLine[0]=0x00000001;
	
		MapleSend(&outMapleFrame);
	
	if(MapleReceive(&inMapleFrame) == RCV_OK)
	{
		//Extract Da Ua Ra La
			joy_state[7]=~MapleFrame.DataLine[4+0];//&0x0F;
			joy_state[6]=~MapleFrame.DataLine[4+1];

			joy_state[0]=0x80;
			joy_state[1]=0x80;
			if(joy_state[7]&_BV(6))
				joy_state[0]=0x0;
			else if(joy_state[7]&_BV(7))
				joy_state[0]=0xff;

			if(joy_state[7]&_BV(4))
				joy_state[1]=0x00;
			else if(joy_state[7]&_BV(5))
				joy_state[1]=0xff;
		//Extract Analog stick
			joy_state[2]=MapleFrame.DataLine[4+4];
			joy_state[3]=MapleFrame.DataLine[4+5];
		//Extract triggers
			joy_state[4]=MapleFrame.DataLine[4+2];
			joy_state[5]=MapleFrame.DataLine[4+3];
		//Extract another analog stick
//			joy_state[6]=MapleFrame.DataLine[4+6];
//			joy_state[7]=MapleFrame.DataLine[4+7];
		//Buttons
			joy_state[7]&=0x0F;

		return CompareReport();

	//		return FALSE;
	}
	
}


/*----------------------------------------------------------------------------
  Set HID Output Report <- OutReport
 *----------------------------------------------------------------------------*/
void SetOutReport (void) 
{
//  GPIOB->ODR = (OutReport << 8);	                 // All LED Bits are set
}


/*----------------------------------------------------------------------------
  MAIN function
 *----------------------------------------------------------------------------*/
int main (void) {

  stm32_Init ();                                     // STM32 Initialization

  USB_Init();                                        // USB Initialization
  USB_Connect(TRUE);                                 // USB Connect

  while (1) {                                        // Loop forever
    ;
  } // end while
} // end main
