/*----------------------------------------------------------------------------
 * Name:    mielib.c
 * Purpose: MAPLE BUS sample device usage for STM32
 * Version: V1.00
 *----------------------------------------------------------------------------
 * This file is part of the OnAMAPLE tools.
 *
 * Copyright (c) 2007-2013 r.a.m. Factory STORE. All rights reserved.
 *----------------------------------------------------------------------------*/

#include <stm32f10x_lib.h>                        // STM32F10x Library Definitions
#include "STM32_Init.h"                           // STM32 Initialization

#include "../MIELIB/inc/maplebus.h"
#include "../MIELIB/inc/interfaces.h"

/*----------------------------------------------------------------------------
  MAIN function
 *----------------------------------------------------------------------------*/
int main (void) {

	unsigned char bNumbersOfTramsmits = 3;
  stm32_Init ();                                  // STM32 setup
	
	InitMaplePins();
//Setup Interrupts
	DisableMapleEXTI();
	DisMIECOMP();

	while(1)
	{
		if(MapleReceive(&inMapleFrame) == RCV_OK)
		{
			bNumbersOfTramsmits = 3;
			ProcessDeviceFrame(&inMapleFrame);
		}
		else
		{
				if(bNumbersOfTramsmits != 0)
				{
					bNumbersOfTramsmits--;
					inMapleFrame.Command = TransmitAgain;
					 inMapleFrame.DestAP = inMapleFrame.OriginAP;
						if(m_bOurDeviceAddress != 0xFF)
							inMapleFrame.OriginAP = m_bOurDeviceAddress;
						else
						{
							//We do not receive address for this device
						}
					   inMapleFrame.DataSize=0;
						MapleSend(&inMapleFrame);
				}
		}
	}

} // end main
