#ifndef CONTROLLER
#define CONTROLLER

#include <stdbool.h>

#include "MapleFuncs.h"

/*
bit			7	6	5	4	3	2	1	0
1st Data	Ra	La	Da	Ua	St	A	B	1
2nd Data	1	1	1	1	1	X	Y	1
3rd Data	A17	A16	A15	A14	A13	A12	A11	A10
4th Data	A27	A26	A25	A24	A23	A22	A21	A20
5th Data	A37	A36	A35	A34	A33	A32	A31	A30
6th Data	A47	A46	A45	A44	A43	A42	A41	A40
7th Data	1	0	0	0	0	0	0	0
8th Data	1	0	0	0	0	0	0	0
*/
#define	Ra		0x07
#define	La		0x06
#define	Da		0x05
#define	Ua		0x04
#define	Start	0x03
#define	A		0x02
#define	B		0x01
#define	X		0x02
#define	Y		0x01

typedef struct tagCONTROLLERCONDITION
{
	unsigned long FunctionType;
	unsigned char ButtonsLO;
	unsigned char ButtonsHI;
	unsigned char AR_axis;
	unsigned char AL_axis;
	unsigned char Xa_axis;
	unsigned char Ya_axis;
	unsigned char Not_used_A;	//Must be 0x80
	unsigned char Not_used_B;	//ust be 0x80
}CONTROLLERCONDITION,*LPCONTROLLERCONDITION;

bool GetDeviceCondition(LPCONTROLLERCONDITION ContCond);
void ResetMapleDevice(LPMAPLEFRAME MPFrame);
void ProcessDeviceFrame(LPMAPLEFRAME MPFrame);

#endif
