#include <string.h>

/* Storrage access functions */

/*
	OneBlockRead(
		unsigned char lpbBuffer,			//Pointer for received data buffer
		unsigned short wBlockNumber		//Block number for read
		)
	
	return: Receive Status
*/

unsigned char *OneBlockRead(unsigned short wBlockNumber)
{
	/* Get Media Info */
	outMapleFrame.Command  = BlockRead;
	outMapleFrame.DestAP	 = AP_PORTA | EXP_DEV1;
	outMapleFrame.OriginAP = AP_PORTA;
	outMapleFrame.DataSize = 0x02;
	/* And Eddition data */
	outMapleFrame.Data.dwLine[0] = STORRAGE;
	/* Specifies the partition number, always 0x00 */
	outMapleFrame.Data.bLine[0x4] = 0x00;
	/* Specifies the phase. Start from 0x00, next read 0x01 and etc...*/
	outMapleFrame.Data.bLine[0x5] = 0x00;
	outMapleFrame.Data.bLine[0x6] = (wBlockNumber>>0x08) & 0xFF;
	outMapleFrame.Data.bLine[0x7] = wBlockNumber & 0xFF;
	/* Send prepared packet */
	MapleSend(&outMapleFrame);
	/* Receive Answer */
	if(MapleReceive(&inMapleFrame) != RCV_OK)
		return 0x00000000;
	/*Check for device valid report*/
	if(inMapleFrame.Command != DataTransfer)
		return 0x00000000;
	/* Return Receive State*/
	return outMapleFrame.Data.bLine;
}

/* Storrage access functions */

/*
	OneBlockWrite(
		unsigned short wBlockNumber		//Block number for write
		unsigned char lpbBuffer,			//Pointer for write data
		)
	
	return: Receive Status
*/

unsigned char OneBlockWrite(unsigned short wBlockNumber, unsigned char *lpbBuffer)
{
	unsigned char bRet;
	/* Get Media Info */
	outMapleFrame.Command  = BlockWrite;
	outMapleFrame.DestAP	 = AP_PORTA | EXP_DEV1;
	outMapleFrame.OriginAP = AP_PORTA;
	/*2 + 512/4 Bytes of data*/
	outMapleFrame.DataSize = 0x80 + 2;
	/* And Eddition data */
	outMapleFrame.Data.dwLine[0] = STORRAGE;
	/* Specifies the partition number, always 0x00 */
	outMapleFrame.Data.bLine[0x4] = 0x00;
	/* Specifies the phase. Start from 0x00, next write 0x01 and etc...*/
	outMapleFrame.Data.bLine[0x5] = 0x00;
	outMapleFrame.Data.bLine[0x6] = (wBlockNumber>>0x08) & 0xFF;
	outMapleFrame.Data.bLine[0x7] = wBlockNumber & 0xFF;
	/*Copy data to output buffer*/
	memcpy(outMapleFrame.Data.bLine + 8,lpbBuffer,0x200);
	/* Send prepared packet */
	MapleSend(&outMapleFrame);
	/* Receive Answer */
	bRet = MapleReceive(&inMapleFrame);
	/* Assign data with receiver buffer*/
	lpbBuffer = inMapleFrame.Data.bLine;
	/*Check for device valid report*/
	if(bRet != RCV_OK)
		return bRet;

	/* Check For Writes Error */
	outMapleFrame.Command  = GetLastError;
	outMapleFrame.DestAP	 = AP_PORTA | EXP_DEV1;
	outMapleFrame.OriginAP = AP_PORTA;
	outMapleFrame.DataSize = 0x00;
	MapleSend(&outMapleFrame);
	/* Receive Answer */
	bRet = MapleReceive(&inMapleFrame);
	
	if(bRet != RCV_OK)
		return bRet;
	
	if(inMapleFrame.Command != DeviceReply)
	{
		//If device does not report, return some error
		return 0xFF;
	}
	/* Return Receive State*/
	return bRet;
}

