#include "maplebus.h"
/*
__global_reg(1) int __SOPCounter;
__global_reg(2) int __EOPCounter;
__global_reg(3) int __TMPCounter;
__global_reg(4) int __DTACounter;
*/

// unmask interrupts
#define EnableMapleEXTI()	EXTI->IMR	|= 0x03
// mask interrupts, and mask pending flags
#define DisableMapleEXTI()	EXTI->IMR	&= ~0x03; EXTI->PR	|= 0x03

// mask RCV Start IRQ
#define DisRCVRDetect()	EXTI->IMR	&= ~0x02
// unmask RCV Start IRQ
#define EnRCVRDetect()	EXTI->IMR	|= 0x02

// Get data detect status
#define IsDTADetectEnabled()	(EXTI->IMR	& 0x01)
// mask data byte receive IRQ
#define DisDTADetect()	EXTI->IMR	&= ~0x01
// unmask data byte receive IRQ
#define EnDTADetect()	EXTI->IMR	|= 0x01

/*Init Mapple IO pins on current controller*/
/*Pull Up all pins*/
#define InitMaplePins() 	GPIOA->ODR = 0xFFFF; GPIOB->ODR = 0xFFFF

/*Define CPLD MIE Companion Pins*/

#define	nDLatch			(GPIO_Pin_0)	//Data latched for read, DATA LATCH on Negative pulse
#define	nSTRCV			(GPIO_Pin_1)	//Receive start on positive pulse
#define	nRST				(GPIO_Pin_2)	//Device hard reset from host, RESET = 0
#define	RxD					(GPIO_Pin_3)	//Receive in progress, RECEIVE = 1
#define	INHTxD			(GPIO_Pin_4)	//Inhibit MIE Companion signals detection, INHIBIT = 1
#define	FERR				(GPIO_Pin_5)	//Frame Error, ERROR = 1
#define	EOP					(GPIO_Pin_6)	//End of packet detection, ERROR = 1

#define EnMIECOMP()		GPIOA->BRR = INHTxD
#define DisMIECOMP()	GPIOA->BSRR = INHTxD
